---
title: CSSStyleSheet.addRule()
slug: Web/API/CSSStyleSheet/addRule
tags:
  - API
  - CSS
  - CSSOM
  - CSSOM API
  - CSSStyleSheet
  - Layout
  - Method
  - Object Model
  - Obsolete
  - Reference
  - Style
  - StyleSheet
  - addRule
  - legacy
  - rules
---
<p>{{APIRef("CSSOM")}}{{obsolete_header}}</p>

<p>The obsolete {{domxref("CSSStyleSheet")}} interface's <code><strong>addRule()</strong></code> <em>legacy method</em> adds a new rule to the stylesheet. You should avoid using this method, and should instead use the more standard {{domxref("CSSStyleSheet.insertRule", "insertRule()")}} method.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>result</em> = <em>cssStyleSheet</em>.addRule(<em>selector</em>, <em>styleBlock</em>, <em>index</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>selector</code></dt>
 <dd>A {{domxref("DOMString")}} specifying the selector portion of the CSS rule. The default is the string <code>undefined</code>.</dd>
 <dt><code>styleBlock</code></dt>
 <dd>A {{domxref("DOMString")}} indicating the style block to apply to elements matching the <code>selector</code>. The default is the string <code>undefined</code>.</dd>
 <dt><code>index</code> {{optional_inline}}</dt>
 <dd>An optional index into the stylesheet's {{domxref("CSSRuleList")}} at which to insert the new rule. If <code>index</code> is not specified, the next index after the last item currently in the list is used (that is, the value of <code>cssStyleSheet.cssRules.length</code>).</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>Always returns -1.</p>

<p>Note that due to somewhat estoteric rules about where you can legally insert rules, it's possible that an exception may be thrown. See {{domxref("CSSStyleSheet.insertRule", "insertRule()")}} for more information.</p>

<h2 id="Usage_notes">Usage notes</h2>

<p>This method is implemented by browsers by constructing a string using the template literal <code>`${selector}{${styleBlock}}`</code>, then passing it into the standard {{domxref("CSSStyleSheet.insertRule", "insertRule()")}} method.</p>

<p>Therefore, given existing code such as the following:</p>

<pre class="brush: js">cssStyleSheet.addRule(selector, styles, 0);</pre>

<p>You can rewrite this to use the more standard <code>insertRule()</code> like this:</p>

<pre class="brush: js">cssStyleSheet.insertRule(`${selector} {${styles}}`, 0);</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th>Specification</th>
   <th>Status</th>
   <th>Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("CSSOM", "#dom-cssstylesheet-addrule", 'CSSStyleSheet.addRule()')}}</td>
   <td>{{Spec2("CSSOM")}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CSSStyleSheet.addRule")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/CSS_Object_Model">CSS Object Model</a></li>
 <li><a href="/en-US/docs/Web/API/CSS_Object_Model/Using_dynamic_styling_information">Using dynamic styling information</a></li>
</ul>
